// MulticastClient.java


import java.io.*;
import java.net.*;
import java.util.*;


public class MulticastClient {
	

    public static void main(String[] args) throws IOException {

				// creazione della socket multicast
        MulticastSocket socket = new MulticastSocket(MulticastServer.PORT);
        socket.setSoTimeout(20000);
        InetAddress address = InetAddress.getByName("230.0.0.1");
        System.out.println("MulticastClient: started");
				System.out.println("Socket: "+ socket);


        // adesione al gruppo associato all'indirizzo multicast
        socket.joinGroup(address);
        System.out.println("Joining to "+ address);


        DatagramPacket packet;
    
        // ricezione di alcune linee        
        for (int i = 0; i < 5; i++) {

            byte[] buf = new byte[256];
            packet = new DatagramPacket(buf, buf.length);
            socket.receive(packet);

            String received = new String(packet.getData());
            System.out.println("Line got: " + received);
        }

				// uscita dal gruppo e chiusura della socket
        System.out.println("Leaving group...");
        socket.leaveGroup(address);
        System.out.println("MulticastClient: closing...");
        socket.close();
    }

}