// MulticastServer.java



import java.io.*;
import java.net.*;
import java.util.*;



public class MulticastServer extends LineServer{
	

    public MulticastServer(){
    	super();
    }
    
    public static void main(String[] args) throws IOException {
        
      long WAIT = 1000;
      int count=0;
      
      System.out.println("MulticastServer: started");
      MulticastServer server=new MulticastServer();
      // creazione del gruppo associato all'indirizzo multicast
      InetAddress group = InetAddress.getByName("230.0.0.1");
      System.out.println("Creating group "+ group);

      while (moreLines) {
            try {
            	count++;
                byte[] buf = new byte[256];

                // costruzione della linea                
                String dString = null;
                if (in == null) dString = new Date().toString();
                else dString = getNextLine();
                if (dString!=null) {
                	buf = dString.getBytes();
                
                  // "impacchettamento" e invio della linea al gruppo
                  DatagramPacket packet = new DatagramPacket(buf, buf.length, group, PORT);
                  server.socket.send(packet);
                  System.out.println("Sending line # "+ count);
                }

								// attesa tra un invio e l'altro...
                try {
                    Thread.sleep((long)(Math.random() * WAIT));
                } catch (InterruptedException e) { }
              } catch (IOException e) {
                  e.printStackTrace();
                  moreLines = false;
            }
        }
     System.out.println("No more lines. Goodbye.");
     System.out.println("MulticastServer: closing...");
     server.socket.close();
    }
}